import os
os.environ['PYGAME_HIDE_SUPPORT_PROMPT'] = "hide"
import pygame


pygame.init()

SCREEN_WIDTH = 800
SCREEN_HEIGTH = 600
FPS = 60
STEP_SIZE = 4

screen = pygame.display.set_mode((SCREEN_WIDTH, SCREEN_HEIGTH))
player = pygame.Rect((300,250,50,50))

clock = pygame.time.Clock()
run = True
while run:
    screen.fill((0, 0, 0))
    pygame.draw.rect(screen, (255, 0, 0), player)

    key = pygame.key.get_pressed()
    if key[pygame.K_a] == True:
        player.move_ip((-1 * STEP_SIZE), 0)
    elif key[pygame.K_d] == True:
        player.move_ip((1 * STEP_SIZE), 0)
    elif key[pygame.K_w] == True:
        player.move_ip(0, (-1 * STEP_SIZE))
    elif key[pygame.K_s] == True:
        player.move_ip(0, (1 * STEP_SIZE))

    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            run = False

    pygame.display.update()
    clock.tick(FPS)

    
pygame.quit()